--[[
RampageAI̎|[Vsb`[u܂B
AIɂق̏̕ύXŎg悤ɂȂĂ܂B

Place it in a file (e.g., AidPot.lua) and add a "require" statement in Custom.lua. That causes
the standard Aid Potting function to be replaced.

In the current version it will NOT try other potions than the one you specify.

In case the number of retries is exceeded, you can reset the function by Vaporize/Call.

Look at the configuration parameters a bit further down and set them to your liking. It
will not work if you set in Config.lua (unless you remove the parameters from this file)

You will notice that SP potting is also implemented. I recommend to use it only in WoE/
PvP/MVP. Otherwise it could be an expensive story!!

I partly understand the reason for Faithfull's implementation of Aid Potting. To help
when you are not able to Pot in a Mob. But being mobbed is also part of the game and
even Priests are not able to buff a character in a Mob. So it is not too unfair to pot
generally when your Homun's HP/SP gets low.
I also wrote this function because I am quite annoyed with the Homun Resurrection. LV 5
saves you some SP, but you still have the same cast time and the amount of HP restored is
random from about 10% to 90%. This function will allow Resurrection LV 1, and heal the
Homun right away to an acceptable lv. I use 80 for WoE/PvP so I can Vaporize if needed.

]]--

-- Here are the configuration parameters (Adjust as you please)

HPPotType = 2	-- White Pot type (3 = Yellow, 2 = Orange, 1 = Red)
AidPotHP = 30	-- Value to trigger Potting. Set to 0 to disable
AidPotSP = 0	-- Value to trigger Potting. Set to 0 to disable


MaxHPRetries = 5 -- Or whatever you want. 5 will disable within 3 secs if failing to pot
MaxSPRetries = 5 -- Ditto.
EnableAidPotSearch = false -- NOT implemented yet


-- Global variables for the AidPotion complex (Do NOT change)

NextAidPot = 0
AidPotSearch = false
EnableAidPotSearch = false
MaxSPRetries = 5
CheckAidPotSuccess = false
HPPot = 1
SPPot = 2
LastPotType = 0
HPPotWentBad = false
SPPotWentBad = false
HPAidPotRetries = 0
SPAidPotRetries = 0
LastHomunHP = 0
LastHomunSP = 0
AidPotSearch = false




-- Function to check (and use) Aid Potion if necessary
function Fallen_AidPotion()

	-- Check if our owner is sitting down.
	if GetV(V_MOTION,OwnerID) == MOTION_SIT then
		-- We can't do anything :(
		return
	end

	-- Get the tick count
	local ticks = GetTick()

	local HomunHP = HPPercent(HomunID)
	local HomunSP = GetV(V_SP,HomunID)
		
	-- Check for success of the last AidPot
	-- The reason for checking often it to minimize the risk of
	-- hits being seen as a failure to Aid Pot
	
	if CheckAidPotSuccess then
		-- Check for HP or SP Pot success
				
		if LastPotType == HPPot then
			-- Checking for HP
			if LastHomunHP < HomunHP then
				-- Looks like last potting went OK
				CheckAidPotSuccess = false
				HPPotWentBad = false
			else
				-- Looks like it went bad
				HPPotWentBad = true
			end
		elseif LastPotType == SPPot then
			-- Checking for SP
			if LastHomunSP < HomunSP then
				-- Looks like last potting went OK
				CheckAidPotSuccess = false
				SPPotWentBad = false
			else
				-- Looks like it went bad
				SPPotWentBad = true
			end
		end
	end



	-- Check if the .5 sec Cast delay has expired
	
	if ticks < NextAidPot then
		-- Nope, return
		return
	end
	
	-- Check if we are searching for a Potion (not implemented yet!!)
	
	if AidPotSearch and EnableAidPotSearch then
		-- Go search
		AidPotSearch()
	end
	
	-- Check the HP first (Priority over SP potting)
	
	
	if HomunHP <= AidPotHP and HPAidPotRetries < MaxHPRetries then
		-- First set the retry counter
		if HPPotWentBad then
			HPAidPotRetries = HPAidPotRetries + 1
		else
			HPAidPotRetries = 0
		end
		-- Then we do the actual potting
		SkillObject(HomunID, HPPotType, 231, HomunID)
		-- Set the variables for potting check
		CheckAidPotSuccess = true
		LastPotType = HPPot
		LastHomunHP = HomunHP
		CheckAidPotSuccess = true
		NextAidPot = ticks + 500
		
	-- Or the SP
		
	elseif HomunSP < AidPotSP and SPAidPotRetries < MaxSPRetries then
		-- First set the retry counter
		if SPPotWentBad then
			SPAidPotRetries = SPAidPotRetries + 1
		else
			SPAidPotRetries = 0
		end
		-- Then we do the actual potting
		SkillObject(HomunID, 5, 231, HomunID)
		-- Set the variables for potting check
		CheckAidPotSuccess = true
		LastPotType = SPPot
		LastHomunSP = HomunSP
		CheckAidPotSuccess = true
		NextAidPot = ticks + 500
	end

		
end

-- This function will search for Pots if we run out of one type
-- It might be implemented or maybe not!!!

function AidPotSearch()
end

-- HP should be in %. This function does that

function HPPercent(actor)
	-- Get the actor's HP and max HP amounts
	local hp = GetV(V_HP,actor)
	local max = GetV(V_MAXHP,actor)

	-- Turn it into a percentage and return
	return math.floor( (hp/max) * 100 )
end
