--[[

̃t@CRampageAÏꕔłB

RampageAI̓t[\tgł; Free Software FoundationzGNUʌOp_񏑂̏̂ƂōĔzzщς邱Ƃł܂;
GNUCZXo[W2A܂(Ȃ̑I)2ȑÕo[WɂāB

RampageAÍALpłƂ]Ĕzz܂B
*ۏ؂Ȃ*; s̐A̖ړÎ߂̓K̈ÖٓIȕۏ؂ȂĂB 
̑̏ڍׂɊւẮAGNUʌOp_񏑂ĂB

RampageAIƋGNUʌOp_񏑂̃Rs[𓯎Ɏ󂯎ׂł;
łȂȂAȉ̏֏ȂB
Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

--]]

------------------------
-- Sequence Processor --
------------------------

function ProcessSequence()
	-- Loop until a sequence doesn't tell us to keep going
	local cont,seq,func
	repeat
		-- Make sure there are sequences in our stack
		if List.size(AI_seq) < 1 then
			break
		end

		-- Grab the sequence
		seq = List.popleft(AI_seq)

		-- Determine which function to call
		if seq[1] == SEQ_MOVE then
			func = SEQ_PMove
		elseif seq[1] == SEQ_ATTACK then
			func = SEQ_Attack
		elseif seq[1] == SEQ_SKILL_OBJECT then
			func = SEQ_ASkill
		elseif seq[1] == SEQ_SKILL_AREA then
			func = SEQ_PSkill
		elseif seq[1] == SEQ_MOVE_TO then
			func = SEQ_AMove
		elseif seq[1] == SEQ_SET_TARGET then
			-- Set the target
			Target.Previous = Target.ID
			Target.ID = seq[2]
			Target.Lock = seq[3]

			-- The function will return true to move on
			-- to the next target
			func = TrueReturn
		elseif seq[1] == SEQ_SET_HOLD then
			-- Set the HoldPosition variable
			HoldPosition = seq[2]

			-- Return true to continue sequencing
			func = TrueReturn
		else
			func = SEQ_Custom
		end

		-- Call the function
		cont,seq,seq2 = func(seq)

		-- If a sequence is given back, push it onto the stack
		if seq~= nil then
			-- If 2 are given back, put the 2nd of the stack
			-- first, so its executed 2nd
			if seq2 ~= nil then
				List.pushleft(AI_seq,seq2)
			end

			-- Put the 1st sequence on the stack
			List.pushleft(AI_seq,seq)
		end
	until cont ~= true

	-- Return the next sequence
	if List.size(AI_seq) > 0 then
		return AI_seq[AI_seq.first]
	end

	-- No sequences, return a blank sequence
	return { SEQ_NONE }
end

---------------------------------
-- Sequencer Support Functions --
---------------------------------

function InSequence(type)
	-- Check the size of AI_seq
	if List.size(AI_seq) < 1 then
		return false
	end

	-- Loop through AI_seq
	for i=AI_seq.first,AI_seq.last do
		-- Check the sequence type
		if AI_seq[i][1] == type then
			return true
		end
	end

	-- Default to false
	return false
end

-------------------------------
-- Default Sequence Handlers --
-------------------------------

-- Move to a position
function SEQ_PMove(seq)
	-- Grab destination
	local destx = seq[2]
	local desty = seq[3]

	-- Grab current position
	local x,y = GetV(V_POSITION,HomunID)

	-- Check if we're currently moving
	if GetV(V_MOTION,HomunID) ~= MOTION_MOVE then
		-- We aren't moving

		-- Check if destination is out of sight
		if not IsInSight(destx,desty) then
			-- Process the next sequence
			return true
		end

		-- Increment the number of tries to move
		if seq.tries == nil then
			seq.tries = 1
		else
			seq.tries = seq.tries + 1
		end

		-- Check if we were standing still before
		if seq.oldx ~= nil then
			-- Check if we've arrived
			if PPDistance(x,y,destx,desty) < 2 then
				-- We've arrived!

				-- Log it
				Log("Movement completed")

				return true

				--[[ Note: this is inside the check for
					oldx and oldy so that commands
					to move 1 square away are not
					ignored
				--]]
			end

			-- Check if we got stuck
			if PPDistance(seq.oldx,seq.oldy,x,y) < 2 then
				-- We got stuck, go to next sequence

				-- Check if we haven't tried 2 times before
				if seq.tries < 3 then
					-- Try again, once
				else
					-- Log it
					Log("Stuck, discarding movement command.")

					return true
				end
			else
				-- Reset the tries meter
				seq.tries = 0
			end
		else
			-- First time trying this move, log it
			Log("Moving to position: (%d,%d)",destx,desty)
		end

		-- Save the coordinates we're at
		seq.oldx = x
		seq.oldy = y

		-- Make sure our distance isn't too far
		while PPDistance(x,y,destx,desty) > 12 do
			-- Make a shorter move
			destx = x-math.floor((x-destx)/2)
			desty = y-math.floor((y-desty)/2)
		end

		-- Move towards our destination
		Move(HomunID,destx,desty)

		-- And continue checking
		return false,seq
	else
		-- We're moving

		-- Check if destination is out of sight
		if not IsInSight(destx,desty) then
			-- Stop moving, by moving to ourself
			Move(HomunID,x,y)

			-- Process the next sequence
			return true
		end

		-- Put the sequence back on the AI_seq stack
		return false,seq
	end
end

-- Move to an actor
function SEQ_AMove(seq)
	-- Get our target's coordinates
	local destx,desty = GetV(V_POSITION,seq[2])

	-- Check that its a valid actor
	if destx == -1 then
		return true
	end
	
	-- Check the distance from the actor we want to be
	if seq[3] == nil then
		-- Default it to 0
		seq[3] = 0
	end

	-- Make sure the distance is valid
	if seq[3] < 0 then
		seq[3] = 0
	end

	-- Get our coordinates
	local x,y = GetV(V_POSITION,HomunID)

	-- Check if we're moving
	if GetV(V_MOTION,HomunID) ~= MOTION_MOVE then
		-- We're not moving

		-- Check if our actor is in sight
		if not IsInSight(destx,desty) then
			-- Log
			Log("Actor moved out of sight, discarding follow command.")

			-- Go to next sequence
			return true
		end

		-- Check if we have coordinates of us stopped elsewhere
		if seq.oldx ~= nil then
			-- Never ignore moving towards our owner
			if seq[2] ~= OwnerID then
				-- Check if we got stuck in the same
				-- place before
				if PPDistance(seq.oldx,seq.oldy,x,y) < 2 then
					-- We're probably stuck :(

					-- Log it
					Log("Stuck, discarding follow command.")

					return true
				end
			end

			-- Check if we've arrived
			local targetDist = seq[3]
			if targetDist < 2 then
				targetDist = 2
			end
			if PPDistance(x,y,destx,desty) <= targetDist then
				-- Log it
				Log("Arrived at target")

				-- Go to next sequence
				return true
			end
		else
			-- First time moving towards the actor, log it
			Log("Following actor #%d, until we're within %d distance of it",
				seq[2], seq[3])
		end

		-- Save the coordinates we're at
		seq.oldx = x
		seq.oldy = y

	else
		-- We're moving

		-- Check if our actor is in sight
		if not IsInSight(destx,desty) then
			-- Move to ourself to stop moving
			Move(HomunID,x,y)

			-- Log
			Log("Actor moved out of sight, discarding follow command.")

			-- Go to next sequence
			return true
		end

		-- Check if we've arrived
		local targetDist = seq[3]
		if targetDist < 2 then
			targetDist = 2
		end
		if PPDistance(x,y,destx,desty) < targetDist then
			-- Stop moving
			Move(HomunID,x,y)

			-- Log it
			Log("Arrived at target")

			-- Go to next sequence
			return true
		end

		-- Check if our target is still at the same spot
		if seq.olddestx == destx and seq.olddesty == desty
			and seq.calcahead ~= true then
			-- No need to send the move command again,
			-- just continue checking later
			return false,seq
		end

	end

	-- By default, we won't be calculating ahead
	seq.calcahead = false

	-- Check if our target is moving
	if GetV(V_MOTION,seq[2]) == MOTION_MOVE then
		-- Target is moving

		-- Newly calculated destination
		local newdestx=destx
		local newdesty=desty

		-- Check if we have data from where they used to be
		if seq.olddestx ~= nil then
			-- We do, calculate a bit ahead of them
			seq.calcahead = true

			-- Get the direction
			local xdelta = destx-seq.olddestx
			local ydelta = desty-seq.olddesty

			-- Move half the distance they just moved ahead
			-- of them
			newdestx=newdestx + xdelta/2
			newdesty=newdesty + ydelta/2
		end

		-- Save the targets location
		seq.olddestx=destx
		seq.olddesty=desty

		-- Use the newly calculated destination
		destx=newdestx
		desty=newdesty

	else
		-- Target isn't moving

		-- Save the coordinates our target is at
		seq.olddestx = destx
		seq.olddesty = desty
	end
	
	-- Check if we don't want to be hugging them
	if seq[3] ~= 0 then
		-- Get our distance
		local dist = PPDistance(x,y,destx,desty)
		
		-- Get the ratio of our distance, to the distance we need to move
		local distratio = (dist-seq[3]) / dist
		
		-- Modify the destination
		destx = x-math.ceil( (x-destx) * distratio )
		desty = y-math.ceil( (y-desty) * distratio )
	end

	-- Make sure we can move the distance
	while PPDistance(x,y,destx,desty) > 12 do
		-- Make a shorter move
		destx = x-math.floor((x-destx)/2)
		desty = y-math.floor((y-desty)/2)
	end

	-- Move towards our target
	Move(HomunID,destx,desty)

	-- Continue checking
	return false,seq
end

-- Attack
function SEQ_Attack(seq)
	-- Make sure we have a valid target
	if Target.ID == -1 then
		-- Log it
		Log("Invalid target, ignoring attack command")
		
		-- Invalid target
		return true
	end
	
	-- Check if our target is dead
	if GetV(V_MOTION,Target.ID) == MOTION_DEAD then
		-- Log it
		Log("Target killed.")

		-- Turn target lock off
		Target.Previous = Target.ID
		Target.ID = -1
		Target.Lock = false

		return true
	end

	-- Check if we would be kill stealing
	if KillSteal(Target.ID) and not Target.Lock then
		-- Log it
		Log("Dropping target, will not kill-steal")

		-- Check if we're moving
		if GetV(V_MOTION,HomunID) == MOTION_MOVE then
			-- Stop moving
			Move(HomunID,GetV(V_POSITION,HomunID))
		end

		-- Set target to -1
		Target.Previous = Target.ID
		Target.ID = -1

		return true
	end
	
	-- Get our range
	local range = HomunRange

	-- Check if our target should only have skills used against it
	local skillsOnly = false
	if not MAttackAllowed(Target.ID) and MSkillsAllowed(Target.ID) then
		range = HomunSkillRange - 2
		skillsOnly = true
	end
	
	-- Get our coordinates
	local x,y = GetV(V_POSITION,HomunID)

	-- Check if our target is in range of us
	local dist = APDistance(Target.ID,x,y)
	if dist < range then
		-- Check if we're using only skills
		if not skillsOnly then
			-- Set the target lock, so we don't start attacking
			-- something else
			Target.Lock = true
		
			-- Signal to attack
			SendAttack(Target.ID)
		else
			-- Signal to send a skill, and lock if we should
			if SendAttackSkill(Target.ID) then
				Target.Lock = true
			end
		end

		-- Remove failed coords
		seq.failx = nil
	else
		-- Check if our target is in sight range of our owner
		if not ActorIsInSight(Target.ID) then
			-- Log it
			Log("Lost sight to target, or target respawned.")

			-- Ensure target lock is off
			Target.Previous = Target.ID
			Target.ID = -1
			Target.Lock = false

			return true
		end

		-- See if using a skill against them will work
		if SendAttackSkill(Target.ID) and not Target.Lock then
			Target.Lock = true
		end

		--[[

The next part deals with a special sub-sequence to move towards the target.
This is used as a subsequence rather than a direct sequencer command in
the case that the target should change while chasing after it.

		--]]

		-- Check if we have a sub-sequence to chase them
		if seq.AMove_seq == nil then
			-- Make one
			seq.AMove_seq = { SEQ_MOVE_TO, Target.ID, range - 1 }
			seq.failx = nil
		else
			-- Check if the target changed
			if seq.AMove_seq[2] ~= Target.ID then
				-- Fix it
				-- (note we make a new sub sequence)
				seq.AMove_seq = { SEQ_MOVE_TO, Target.ID, range - 1 }
				seq.failx = nil
			end
		end

		-- Use our sub sequence to get closer
		local trylater, preseq = false, seq.AMove_seq
		trylater,seq.AMove_seq = SEQ_AMove(seq.AMove_seq)

		-- Check if it worked
		if trylater then
			-- Use our old sequence again (it usually gets cleared if trylater is true)
			seq.AMove_seq = preseq

			-- Check if we failed before
			if seq.failx ~= nil and GetV(V_MOTION,HomunID) ~= MOTION_MOVE then
				-- Check if we're at the same place
				if PPDistance(seq.failx,seq.faily,x,y) < 2 then
					-- Log it
					Log("Couldn't get closer to our target, ignoring attack command")

					-- Add them to the ignore list
					AddIgnore(Target.ID)

					-- Remove any target lock
					Target.Previous = Target.ID
					Target.ID = -1
					Target.Lock = false

					-- Don't continue to attack
					return true
				end
			end

			-- Save our coords
			seq.failx=x
			seq.faily=y
		else
			-- Remove saved coords, we didn't fail
			seq.failx=nil
			
			-- Reset the movement subcommand as well
			seq.AMove_seq = nil
		end
	end

	-- Continue to try to attack
	return false,seq
end

-- Use a skill on an actor
function SEQ_ASkill(seq)

--[[ Note:
	This sequencer command is only used when the user manually
	tells us to use a skill
--]]

	-- Check if the target is too far away
	if AADistance(seq[4],HomunID) >
		GetV(V_SKILLATTACKRANGE,HomunID,seq[3]) then

		-- Check if the target is in sight range of our owner
		if not ActorIsInSight(seq[4]) then
			-- Log it
			Log("Lost sight of manual skill (ID: %d, level %d) target #%d",
				seq[3], seq[2], seq[4])

			-- Ignore this command
			return true
		end

		-- We need to get closer to the target, so queue
		-- another sequence ahead of this one (and allow
		-- the sequencer to process it right away)
		return true,{ SEQ_MOVE_TO, seq[4] },seq
	end

	-- Log it
	Log("Casting manual skill (ID: %d, level %d) at Actor #%d",
		seq[3],seq[2],seq[4])

	-- Send our skill-use command
	SkillObject(HomunID,seq[2],seq[3],seq[4])

	-- Allow the sequencer to process the next command
	return true
end

-- Use a skill on a position
function SEQ_PSkill(seq)

--[[ Note:
	This sequencer command is only used when the user manually
	tells us to use a skill
--]]

	-- Check if the target is too far away
	if APDistance(HomunID,seq[4],seq[5]) >
		GetV(V_SKILLATTACKRANGE,HomunID,seq[3]) then

		-- Check if the target is in sight range of our owner
		if not IsInSight(seq[4]) then
			-- Log it
			Log("Lost sight of manual skill (ID: %d, level %d) target area (%d,%d)",
				seq[3], seq[2], seq[4], seq[5])

			-- Ignore this command
			return true
		end

		-- We need to get closer to the target, so queue
		-- another sequence ahead of this one (and allow
		-- the sequencer to process it right away)
		return true,{ SEQ_MOVE, seq[4], seq[5] },seq
	end

	-- Log it
	Log("Casting manual skill (ID: %d, level %d) on location (%d,%d)",
		seq[3],seq[2],seq[4],seq[5])

	-- Send our skill-use command
	SkillGround(HomunID,seq[2],seq[3],seq[4],seq[5])

	-- Allow the sequencer to process the next command
	return true
end